/***************************************************************************
                          mynewlabydialog.h  -  description
                             -------------------
    begin                : Wed Jun 20 2001
    copyright            : (C) 2001 by Ruediger Knoerig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYNEWLABYDIALOG_H
#define MYNEWLABYDIALOG_H

#include <qwidget.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qsizepolicy.h>
#include <qsize.h>
#include <qspinbox.h>

class QPushButton;
class QHGroupBox;

/** minimum width of labyrinth */
const int minwidth = 5;
/** maximum width of labyrinth */
const int maxwidth = 40;
/** default width of labyrinth */
const int defwidth = 10;
/** minimum height of labyrinth */
const int minheight = 5;
/** maximum height of labyrinth */
const int maxheight = 40;
/** default height of labyrinth */
const int defheight = 10;

/**
	* dialog which requests the labyrinth parameters
	* from the user
  * @author Ruediger Knoerig
  */

class MyNewLabyDialog : public QDialog  {
   Q_OBJECT
public: 
	/** default constructor */
	MyNewLabyDialog(QWidget *parent=0, const char *name=0);
	/** default destructor */
	~MyNewLabyDialog();
	/** sizePolicy-Methode */
	QSizePolicy sizePolicy() { return QSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed); }
	/** returns the dimension settings */
	QSize getDimensions() { return QSize(widthspinbox->value(), heightspinbox->value()); }
protected:
	/** stores the size of the labyrinth */
	QSize size;
	/** mainlayout */
	QVBoxLayout *mainlayout;
	/** layout for the buttons */
	QHBoxLayout *buttonlayout;
	/** groupbox for dimension control elements */
	QHGroupBox *dimensiongroupbox;
	/** Accept-Button */
	QPushButton *okbutton;
	/** Reject-Button */
	QPushButton *cancelbutton;
	/** first spinbox for setting the width */
	QSpinBox *widthspinbox;
	/** secound spinbox for setting the height */
	QSpinBox *heightspinbox;
};

#endif
