/***************************************************************************
                          qlabyrinthview.h  -  description
                             -------------------
    begin                : Die 19 Jun 2001 19:28:20 MEST
    copyright            : (C) 2001 by Ruediger Knoerig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QLABYRINTHVIEW_H
#define QLABYRINTHVIEW_H

// include files for QT
#include <qwidget.h>
#include <qpixmap.h>

// application specific includes
#include "qlabyrinthdoc.h"

class QPixmap;
class QSize;
class QLabyrinthDoc;

/**
 * This class provides an incomplete base for your application view. 
 */

class QLabyrinthView : public QWidget
{
  Q_OBJECT
  public:
    QLabyrinthView(QWidget *parent=0, QLabyrinthDoc* doc=0);
    ~QLabyrinthView();

  protected:
  	/** reimplemented for repainting the widget with the labyrinth */
		void paintEvent(QPaintEvent *);
		/** reimplemented to give manual keyboard control to cookie */
		void keyPressEvent(QKeyEvent *);
		/** array with the pixmaps used for the labyrinth */
		QPixmap *fields;
		/** array with the pixmaps used for cookie */
		QPixmap *cookie;
		/** link to doc object (its a friend of it...) */
		QLabyrinthDoc *mydoc;
  protected slots:
    void slotDocumentChanged();
	signals: // Signals
  	/** emitted if a cursor key is pressed  */
  	void moveKeyPressed(QLabyrinthDoc::orientation dir);
};

#endif
